/*-----------------------------------------------------------------------------
                       A c t i v e   W o r l d s   A P I
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                  Copyright 1998-2004 Activeworlds Corp.
        Licensed Material -- Program Property of Activeworlds Corp.
-----------------------------------------------------------------------------*/

#ifdef WIN32
#if !defined (AW_SDK) && !defined (AW_BROWSER) && !defined (AW_STATIC)
#define AWAPI     __declspec (dllimport)
#else
#define AWAPI
#endif
#else
#define AWAPI
#endif

#define AW_MAX_ATTRIBUTE_LENGTH   255
#define AW_CELL_MIN               -32767
#define AW_BUILD                  39

#ifdef __cplusplus
extern "C" {
#endif

/*-----------------------------------------------------------------------------
                             a t t r i b u t e s
-----------------------------------------------------------------------------*/

typedef enum {
  AW_LOGIN_NAME,
  AW_LOGIN_PASSWORD,
  AW_LOGIN_OWNER,
  AW_LOGIN_PRIVILEGE_PASSWORD,
  AW_LOGIN_PRIVILEGE_NUMBER,
  AW_LOGIN_PRIVILEGE_NAME,
  AW_LOGIN_APPLICATION,
  AW_LOGIN_EMAIL,
  AW_UNIVERSE_BROWSER_MINIMUM,
  AW_UNIVERSE_BROWSER_RELEASE,
  AW_UNIVERSE_BROWSER_BETA,
  AW_UNIVERSE_WORLD_MINIMUM,
  AW_UNIVERSE_WORLD_START,
  AW_UNIVERSE_REGISTRATION_REQUIRED,
  AW_UNIVERSE_BUILD_NUMBER,
  AW_UNIVERSE_MONTHLY_CHARGE,
  AW_UNIVERSE_ANNUAL_CHARGE,
  AW_UNIVERSE_REGISTER_METHOD,
  AW_UNIVERSE_TIME,
  AW_UNIVERSE_CITIZEN_CHANGES_ALLOWED,
  AW_UNIVERSE_BROWSER_RELEASE_22,
  AW_UNIVERSE_WELCOME_MESSAGE,
  AW_UNIVERSE_WORLD_RELEASE,
  AW_UNIVERSE_WORLD_BETA,
  AW_UNIVERSE_ALLOW_TOURISTS,
  AW_UNIVERSE_SEARCH_URL,
  AW_CITIZEN_NUMBER,
  AW_CITIZEN_NAME,
  AW_CITIZEN_PASSWORD,
  AW_CITIZEN_EMAIL,
  AW_CITIZEN_TIME_LEFT,
  AW_CITIZEN_PRIVILEGE_PASSWORD,
  AW_CITIZEN_IMMIGRATION_TIME,
  AW_CITIZEN_EXPIRATION_TIME,
  AW_CITIZEN_BETA,
  AW_CITIZEN_LAST_LOGIN,
  AW_CITIZEN_BOT_LIMIT,
  AW_CITIZEN_TOTAL_TIME,
  AW_CITIZEN_ENABLED,
  AW_CITIZEN_COMMENT,
  AW_CITIZEN_URL,
  AW_WORLD_NAME,
  AW_WORLD_TITLE,
  AW_WORLD_BACKDROP,
  AW_WORLD_GROUND,
  AW_WORLD_OBJECT_PATH,
  AW_WORLD_OBJECT_REFRESH,
  AW_WORLD_BUILD_RIGHT,
  AW_WORLD_EMINENT_DOMAIN_RIGHT,
  AW_WORLD_ENTER_RIGHT,
  AW_WORLD_SPECIAL_OBJECTS_RIGHT,
  AW_WORLD_FOG_RED,
  AW_WORLD_FOG_GREEN,
  AW_WORLD_FOG_BLUE,
  AW_WORLD_CARETAKER_CAPABILITY,
  AW_WORLD_RESTRICTED_RADIUS,
  AW_WORLD_PUBLIC_SPEAKER_CAPABILITY,
  AW_WORLD_PUBLIC_SPEAKER_RIGHT,
  AW_WORLD_CREATION_TIMESTAMP,
  AW_WORLD_HOME_PAGE,
  AW_WORLD_BUILD_NUMBER,
  AW_WORLD_OBJECT_PASSWORD,
  AW_WORLD_DISABLE_CREATE_URL,
  AW_WORLD_RATING,
  AW_WORLD_WELCOME_MESSAGE,
  AW_WORLD_EJECT_RIGHT,
  AW_WORLD_EJECT_CAPABILITY,
  AW_WORLD_CELL_LIMIT,
  AW_WORLD_BUILD_CAPABILITY,
  AW_WORLD_ALLOW_PASSTHRU,
  AW_WORLD_ALLOW_FLYING,
  AW_WORLD_ALLOW_TELEPORT,
  AW_WORLD_ALLOW_OBJECT_SELECT,
  AW_WORLD_BOTS_RIGHT,
  AW_WORLD_SPEAK_CAPABILITY,
  AW_WORLD_SPEAK_RIGHT,
  AW_WORLD_ALLOW_TOURIST_WHISPER,
  AW_WORLD_LIGHT_X,
  AW_WORLD_LIGHT_Y,
  AW_WORLD_LIGHT_Z,
  AW_WORLD_LIGHT_RED,
  AW_WORLD_LIGHT_GREEN,
  AW_WORLD_LIGHT_BLUE,
  AW_WORLD_AMBIENT_LIGHT_RED,
  AW_WORLD_AMBIENT_LIGHT_GREEN,
  AW_WORLD_AMBIENT_LIGHT_BLUE,
  AW_WORLD_ALLOW_AVATAR_COLLISION,
  AW_WORLD_FOG_ENABLE,
  AW_WORLD_FOG_MINIMUM,
  AW_WORLD_FOG_MAXIMUM,
  AW_WORLD_MAX_USERS,
  AW_WORLD_SIZE,
  AW_WORLD_OBJECT_COUNT,
  AW_WORLD_EXPIRATION,
  AW_WORLD_SPECIAL_COMMANDS_RIGHT,
  AW_WORLD_MAX_LIGHT_RADIUS,
  AW_WORLD_SKYBOX,
  AW_WORLD_MINIMUM_VISIBILITY,
  AW_WORLD_REPEATING_GROUND,
  AW_WORLD_KEYWORDS,
  AW_WORLD_ENABLE_TERRAIN,
  AW_WORLD_ALLOW_3_AXIS_ROTATION,
  AW_WORLD_TERRAIN_TIMESTAMP,
  AW_WORLD_ENTRY_POINT,
  AW_WORLD_SKY_NORTH_RED,
  AW_WORLD_SKY_NORTH_GREEN,
  AW_WORLD_SKY_NORTH_BLUE,
  AW_WORLD_SKY_SOUTH_RED,
  AW_WORLD_SKY_SOUTH_GREEN,
  AW_WORLD_SKY_SOUTH_BLUE,
  AW_WORLD_SKY_EAST_RED,
  AW_WORLD_SKY_EAST_GREEN,
  AW_WORLD_SKY_EAST_BLUE,
  AW_WORLD_SKY_WEST_RED,
  AW_WORLD_SKY_WEST_GREEN,
  AW_WORLD_SKY_WEST_BLUE,
  AW_WORLD_SKY_TOP_RED,
  AW_WORLD_SKY_TOP_GREEN,
  AW_WORLD_SKY_TOP_BLUE,
  AW_WORLD_SKY_BOTTOM_RED,
  AW_WORLD_SKY_BOTTOM_GREEN,
  AW_WORLD_SKY_BOTTOM_BLUE,
  AW_WORLD_CLOUDS_LAYER1_TEXTURE,
  AW_WORLD_CLOUDS_LAYER1_MASK,
  AW_WORLD_CLOUDS_LAYER1_TILE,
  AW_WORLD_CLOUDS_LAYER1_SPEED_X,
  AW_WORLD_CLOUDS_LAYER1_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER1_OPACITY,
  AW_WORLD_CLOUDS_LAYER2_TEXTURE,
  AW_WORLD_CLOUDS_LAYER2_MASK,
  AW_WORLD_CLOUDS_LAYER2_TILE,
  AW_WORLD_CLOUDS_LAYER2_SPEED_X,
  AW_WORLD_CLOUDS_LAYER2_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER2_OPACITY,
  AW_WORLD_CLOUDS_LAYER3_TEXTURE,
  AW_WORLD_CLOUDS_LAYER3_MASK,
  AW_WORLD_CLOUDS_LAYER3_TILE,
  AW_WORLD_CLOUDS_LAYER3_SPEED_X,
  AW_WORLD_CLOUDS_LAYER3_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER3_OPACITY,
  AW_WORLD_DISABLE_CHAT,
  AW_WORLD_ALLOW_CITIZEN_WHISPER,
  AW_WORLD_ALWAYS_SHOW_NAMES,
  AW_WORLD_DISABLE_AVATAR_LIST,
  AW_WORLD_AVATAR_REFRESH_RATE,
  AW_WORLD_WATER_TEXTURE,
  AW_WORLD_WATER_MASK,
  AW_WORLD_WATER_BOTTOM_TEXTURE,
  AW_WORLD_WATER_BOTTOM_MASK,
  AW_WORLD_WATER_OPACITY,
  AW_WORLD_WATER_RED,
  AW_WORLD_WATER_GREEN,
  AW_WORLD_WATER_BLUE,
  AW_WORLD_WATER_LEVEL,
  AW_WORLD_WATER_SURFACE_MOVE,
  AW_WORLD_WATER_WAVE_MOVE,
  AW_WORLD_WATER_SPEED,
  AW_WORLD_WATER_ENABLED,
  AW_WORLD_EMINENT_DOMAIN_CAPABILITY,
  AW_WORLD_LIGHT_TEXTURE,
  AW_WORLD_LIGHT_MASK,
  AW_WORLD_LIGHT_DRAW_SIZE,
  AW_WORLD_LIGHT_DRAW_FRONT,
  AW_WORLD_LIGHT_DRAW_BRIGHT,
  AW_WORLD_TERRAIN_AMBIENT,
  AW_WORLD_TERRAIN_DIFFUSE,
  AW_WORLD_WATER_VISIBILITY,
  AW_WORLD_SOUND_FOOTSTEP,
  AW_WORLD_SOUND_WATER_ENTER,
  AW_WORLD_SOUND_WATER_EXIT,
  AW_WORLD_SOUND_AMBIENT,
  AW_WORLD_GRAVITY,
  AW_WORLD_BUOYANCY,
  AW_WORLD_ALLOW_TOURIST_BUILD,
  AW_WORLD_ENABLE_REFERER,
  AW_WORLD_WATER_UNDER_TERRAIN,
  AW_WORLD_TERRAIN_OFFSET,
  AW_WORLD_PLACEHOLDER1, // do not use!
  AW_WORLD_DISABLE_MULTIPLE_MEDIA,
  AW_MY_X,
  AW_MY_Y,
  AW_MY_Z,
  AW_MY_YAW,
  AW_MY_PITCH,
  AW_MY_TYPE,
  AW_MY_GESTURE,
  AW_MY_STATE,
  AW_AVATAR_SESSION,
  AW_AVATAR_NAME,
  AW_AVATAR_X,
  AW_AVATAR_Y,
  AW_AVATAR_Z,
  AW_AVATAR_YAW,
  AW_AVATAR_PITCH,
  AW_AVATAR_TYPE,
  AW_AVATAR_GESTURE,
  AW_AVATAR_STATE,
  AW_AVATAR_ADDRESS,
  AW_AVATAR_VERSION,
  AW_AVATAR_CITIZEN,
  AW_AVATAR_PRIVILEGE,
  AW_CHAT_SESSION,
  AW_CHAT_MESSAGE,
  AW_CELL_X,
  AW_CELL_Z,
  AW_CELL_SEQUENCE,
  AW_CELL_SIZE,
  AW_CELL_ITERATOR,
  AW_CELL_COMBINE,
  AW_OBJECT_NUMBER,
  AW_OBJECT_X,
  AW_OBJECT_Y,
  AW_OBJECT_Z,
  AW_OBJECT_YAW,
  AW_OBJECT_TILT,
  AW_OBJECT_ROLL,
  AW_OBJECT_MODEL,
  AW_OBJECT_DESCRIPTION,
  AW_OBJECT_ACTION,
  AW_OBJECT_OLD_NUMBER,
  AW_OBJECT_OLD_X,
  AW_OBJECT_OLD_Z,
  AW_OBJECT_OWNER,
  AW_OBJECT_SESSION,
  AW_OBJECT_BUILD_TIMESTAMP,
  AW_QUERY_COMPLETE,
  AW_CHAT_TYPE,
  AW_LICENSE_NAME,
  AW_LICENSE_PASSWORD,
  AW_LICENSE_USERS,
  AW_LICENSE_RANGE,
  AW_LICENSE_EMAIL,
  AW_LICENSE_COMMENT,
  AW_LICENSE_CREATION_TIME,
  AW_LICENSE_EXPIRATION_TIME,
  AW_LICENSE_LAST_START,
  AW_LICENSE_LAST_ADDRESS,
  AW_LICENSE_HIDDEN,
  AW_LICENSE_ALLOW_TOURISTS,
  AW_WORLDLIST_NAME,
  AW_WORLDLIST_STATUS,
  AW_WORLDLIST_USERS,
  AW_WORLDLIST_RATING,
  AW_WORLDLIST_MORE,
  AW_EJECT_SESSION,
  AW_EJECT_DURATION,
  AW_EJECTION_TYPE,
  AW_EJECTION_ADDRESS,
  AW_EJECTION_EXPIRATION_TIME,
  AW_EJECTION_CREATION_TIME,
  AW_EJECTION_COMMENT,
  AW_DISCONNECT_REASON,
  AW_FILE_RECIPIENT,
  AW_FILE_SENDER,
  AW_FILE_SENDER_NAME,
  AW_FILE_SESSION,
  AW_FILE_ADDRESS,
  AW_FILE_PORT,
  AW_CLICKED_SESSION,
  AW_CLICKED_NAME,
  AW_URL_NAME,
  AW_URL_POST,
  AW_URL_TARGET,
  AW_URL_TARGET_3D,
  AW_TELEPORT_WORLD,
  AW_TELEPORT_X,
  AW_TELEPORT_Y,
  AW_TELEPORT_Z,
  AW_TELEPORT_YAW,
  AW_TELEPORT_WARP,
  AW_SERVER_BUILD,
  AW_SERVER_NAME,
  AW_SERVER_PASSWORD,
  AW_SERVER_REGISTRY,
  AW_SERVER_CARETAKERS,
  AW_SERVER_ID,
  AW_SERVER_ENABLED,
  AW_SERVER_STATE,
  AW_SERVER_USERS,
  AW_SERVER_MAX_USERS,
  AW_SERVER_OBJECTS,
  AW_SERVER_SIZE,
  AW_SERVER_EXPIRATION,
  AW_SERVER_START_RC,
  AW_SERVER_MORE,
  AW_SERVER_TERRAIN_NODES,
  AW_TERRAIN_X,
  AW_TERRAIN_Z,
  AW_TERRAIN_PAGE_X,
  AW_TERRAIN_PAGE_Z,
  AW_TERRAIN_NODE_X,
  AW_TERRAIN_NODE_Z,
  AW_TERRAIN_NODE_SIZE,
  AW_TERRAIN_NODE_TEXTURE_COUNT,
  AW_TERRAIN_NODE_HEIGHT_COUNT,
  AW_TERRAIN_NODE_TEXTURES,
  AW_TERRAIN_NODE_HEIGHTS,
  AW_TERRAIN_SEQUENCE,
  AW_TERRAIN_COMPLETE,
  AW_ENTER_GLOBAL,
  AW_CONSOLE_RED,
  AW_CONSOLE_GREEN,
  AW_CONSOLE_BLUE,
  AW_CONSOLE_BOLD,
  AW_CONSOLE_ITALICS,
  AW_CONSOLE_MESSAGE,
  AW_BOTGRAM_TO,
  AW_BOTGRAM_FROM,
  AW_BOTGRAM_FROM_NAME,
  AW_BOTGRAM_TYPE,
  AW_BOTGRAM_TEXT,
  AW_TOOLBAR_ID,
  AW_TOOLBAR_SESSION,
  AW_USERLIST_MORE,
  AW_USERLIST_NAME,
  AW_USERLIST_WORLD,
  AW_USERLIST_EMAIL,
  AW_USERLIST_CITIZEN,
  AW_USERLIST_PRIVILEGE,
  AW_USERLIST_STATE,
  AW_USERLIST_ADDRESS,
  AW_USERLIST_ENABLED,
  AW_USERLIST_ID,

  /* attributes below are not used by the SDK */

  AW_CONTACT_NUMBER,
  AW_CONTACT_STATUS,
  AW_CONTACT_NAME,
  AW_CONTACT_WORLD,
  AW_CONTACT_MORE,
  AW_CONTACT_OPTIONS,
  AW_TELEGRAM_TO,
  AW_TELEGRAM_FROM,
  AW_TELEGRAM_TEXT,
  AW_TELEGRAM_SENT,
  AW_TELEGRAM_MORE,
  AW_JOIN_NAME,
  AW_JOIN_CITIZEN,
  AW_JOIN_WORLD,
  AW_JOIN_X,
  AW_JOIN_Y,
  AW_JOIN_Z,
  AW_JOIN_YAW,
  AW_REGISTER_CC_NAME,
  AW_REGISTER_CC_NUMBER,
  AW_REGISTER_CC_MONTH,
  AW_REGISTER_CC_YEAR,
  AW_REGISTER_ADDRESS,
  AW_REGISTER_CITY,
  AW_REGISTER_STATE,
  AW_REGISTER_ZIP,
  AW_REGISTER_PHONE_NUMBER,
  AW_REGISTER_BUSINESS_NAME,
  AW_REGISTER_VENDOR,
  AW_REGISTER_RESULT,
  AW_REGISTER_METHOD,
  AW_MAX_ATTRIBUTE
} AW_ATTRIBUTE;

typedef enum {
  AW_EVENT_AVATAR_ADD,
  AW_EVENT_AVATAR_CHANGE,
  AW_EVENT_AVATAR_DELETE,
  AW_EVENT_CELL_BEGIN,
  AW_EVENT_CELL_OBJECT,
  AW_EVENT_CELL_END,
  AW_EVENT_CHAT,
  AW_EVENT_OBJECT_ADD,
  AW_EVENT_OBJECT_DELETE,
  AW_EVENT_UNIVERSE_ATTRIBUTES,
  AW_EVENT_UNIVERSE_DISCONNECT,
  AW_EVENT_WORLD_ATTRIBUTES,
  AW_EVENT_WORLD_INFO,
  AW_EVENT_WORLD_DISCONNECT,
  AW_EVENT_SEND_FILE,
  AW_EVENT_CONTACT_STATE,
  AW_EVENT_TELEGRAM,
  AW_EVENT_JOIN,
  AW_EVENT_OBJECT_CLICK,
  AW_EVENT_OBJECT_SELECT,
  AW_EVENT_AVATAR_CLICK,
  AW_EVENT_URL,
  AW_EVENT_URL_CLICK,
  AW_EVENT_TELEPORT,
  AW_EVENT_ADMIN_WORLD_INFO,
  AW_EVENT_ADMIN_WORLD_DELETE,
  AW_EVENT_TERRAIN_BEGIN,
  AW_EVENT_TERRAIN_DATA,
  AW_EVENT_TERRAIN_END,
  AW_EVENT_CONSOLE_MESSAGE,
  AW_EVENT_TERRAIN_CHANGED,
  AW_EVENT_BOTGRAM,
  AW_EVENT_TOOLBAR_CLICK,
  AW_EVENT_USER_INFO,
  AW_MAX_EVENT
} AW_EVENT_ATTRIBUTE;

typedef enum {
  AW_CALLBACK_LOGIN,
  AW_CALLBACK_ENTER,
  AW_CALLBACK_OBJECT_RESULT,
  AW_CALLBACK_LICENSE_ATTRIBUTES,
  AW_CALLBACK_LICENSE_RESULT,
  AW_CALLBACK_CITIZEN_ATTRIBUTES,
  AW_CALLBACK_CITIZEN_RESULT,
  AW_CALLBACK_QUERY,
  AW_CALLBACK_WORLD_LIST,
  AW_CALLBACK_SEND_FILE,
  AW_CALLBACK_JOIN,
  AW_CALLBACK_PASSWORD_SEND,
  AW_CALLBACK_IMMIGRATE,
  AW_CALLBACK_REGISTER,
  AW_CALLBACK_UNIVERSE_EJECTION,
  AW_CALLBACK_UNIVERSE_EJECTION_RESULT,
  AW_CALLBACK_ADDRESS,
  AW_CALLBACK_WORLD_EJECTION,
  AW_CALLBACK_WORLD_EJECTION_RESULT,
  AW_CALLBACK_ADMIN_WORLD_LIST,
  AW_CALLBACK_ADMIN_WORLD_RESULT,
  AW_CALLBACK_DELETE_ALL_OBJECTS_RESULT,
  AW_CALLBACK_CELL_RESULT,
  AW_CALLBACK_RELOAD_REGISTRY,
  AW_CALLBACK_ATTRIBUTES_RESET_RESULT,
  AW_CALLBACK_ADMIN,
  AW_CALLBACK_CONTACT_ADD,
  AW_CALLBACK_TELEGRAM_RESULT,
  AW_CALLBACK_TERRAIN_SET_RESULT,
  AW_CALLBACK_TERRAIN_NEXT_RESULT,
  AW_CALLBACK_TERRAIN_DELETE_ALL_RESULT,
  AW_CALLBACK_TERRAIN_LOAD_NODE_RESULT,
  AW_CALLBACK_BOTGRAM_RESULT,
  AW_CALLBACK_USER_LIST,
  AW_MAX_CALLBACK
} AW_CALLBACK;

typedef enum {
  AW_CHAT_SAID,
  AW_CHAT_BROADCAST,
  AW_CHAT_WHISPER,
} AW_CHAT_TYPES;

typedef enum {
  AW_CONTACT_OFFLINE,
  AW_CONTACT_ONLINE,
  AW_CONTACT_NOT_A_CITIZEN,
  AW_CONTACT_AFK,
  AW_CONTACT_UNKNOWN
} AW_CONTACT_STATES;

typedef enum {
  AW_WORLDSTATUS_UNKNOWN,
  AW_WORLDSTATUS_PUBLIC,
  AW_WORLDSTATUS_PRIVATE,
  AW_WORLDSTATUS_STOPPED
} AW_WORLD_STATES;

typedef enum {
  AW_SERVER_STOPPED,
  AW_SERVER_STARTING,
  AW_SERVER_START_WAIT,
  AW_SERVER_RUNNING
} AW_SERVER_STATES;

typedef enum {
  AW_CONNECTION_DIRECT,
  AW_CONNECTION_FIREWALL_NO_PROXY,
  AW_CONNECTION_PROXY_AUTO,
  AW_CONNECTION_PROXY_NO_AUTH,
  AW_CONNECTION_PROXY_BASIC,
  AW_CONNECTION_PROXY_AUTH_NTLM,
  AW_CONNECTION_MAX
} AW_CONNECTION_TYPES;

typedef enum {
  AW_CONNECTION_STATE_NOT_CONNECTED,
  AW_CONNECTION_STATE_CONNECTING_TO_PROXY,
  AW_CONNECTION_STATE_NEGOTIATING_WITH_PROXY,
  AW_CONNECTION_STATE_CONNECTING_TO_TUNNEL,
  AW_CONNECTION_STATE_CONNECTING_TO_UNIVERSE,
  AW_CONNECTION_STATE_CONNECTED,
  AW_CONNECTION_STATE_PASSWORD_REQUIRED,
} AW_CONNECTION_STATES;

typedef enum {
  AW_EJECT_BY_ADDRESS,
  AW_EJECT_BY_COMPUTER,
  AW_EJECT_BY_CITIZEN
} AW_EJECTION_TYPES;

typedef enum {
  AW_AVATAR_STATE_WALKING,
  AW_AVATAR_STATE_RUNNING,
  AW_AVATAR_STATE_FLYING,
  AW_AVATAR_STATE_SWIMMING,
  AW_AVATAR_STATE_FALLING,
  AW_AVATAR_STATE_JUMPING,
  AW_AVATAR_STATE_WARPING
} AW_AVATAR_STATES;

typedef enum {
  AW_REGISTER_MONTHLY,
  AW_REGISTER_ANNUAL,
  AW_REGISTER_USER
} AW_REGISTER_METHODS;

/*-----------------------------------------------------------------------------
                                 m e t h o d s
-----------------------------------------------------------------------------*/

AWAPI int   aw_init (int build);
AWAPI void  aw_term (void);
AWAPI int   aw_create (const char* domain, int port, void** instance);
AWAPI int   aw_create_resolved (unsigned long address, int port, void** instance);
AWAPI int   aw_destroy (void);
AWAPI void* aw_instance (void);
AWAPI int   aw_instance_set (void *instance);
AWAPI int   aw_login (void);
AWAPI int   aw_wait (int milliseconds);
AWAPI int   aw_int (AW_ATTRIBUTE a);
AWAPI int   aw_int_set (AW_ATTRIBUTE a, int value);
AWAPI char* aw_string (AW_ATTRIBUTE a);
AWAPI int   aw_string_set (AW_ATTRIBUTE a, const char* value);
AWAPI int   aw_bool (AW_ATTRIBUTE a);
AWAPI int   aw_bool_set (AW_ATTRIBUTE a, int value);
AWAPI float aw_float (AW_ATTRIBUTE a);
AWAPI int   aw_float_set (AW_ATTRIBUTE a, float value);
AWAPI char* aw_data (AW_ATTRIBUTE a, unsigned char* length);
AWAPI int   aw_data_set (AW_ATTRIBUTE a, const char* value, unsigned char length);
AWAPI void  (*aw_callback (AW_CALLBACK c))(int rc);
AWAPI int   aw_callback_set (AW_CALLBACK c, void (*callback) (int rc));
AWAPI void  (*aw_event (AW_EVENT_ATTRIBUTE a))(void);
AWAPI int   aw_event_set (AW_EVENT_ATTRIBUTE a, void (*handler) (void));
AWAPI int   aw_enter (const char* world);
AWAPI int   aw_exit (void);
AWAPI int   aw_say (const char* message);
AWAPI int   aw_whisper (int session_id, const char* message);
AWAPI int   aw_state_change (void);
AWAPI int   aw_citizen_attributes_by_name (const char* name);
AWAPI int   aw_citizen_attributes_by_number (int citizen);
AWAPI int   aw_citizen_add (void);
AWAPI int   aw_citizen_change (void);
AWAPI int   aw_citizen_delete (int citizen);
AWAPI int   aw_citizen_next (void);
AWAPI int   aw_citizen_previous (void);
AWAPI int   aw_license_add (void);
AWAPI int   aw_license_attributes (const char* name);
AWAPI int   aw_license_change (void);
AWAPI int   aw_license_delete (const char* name);
AWAPI int   aw_license_next (void);
AWAPI int   aw_license_previous (void);
AWAPI int   aw_world_list (void);
AWAPI int   aw_object_add (void);
AWAPI int   aw_object_change (void);
AWAPI int   aw_object_delete (void);
AWAPI int   aw_object_load (void);
AWAPI int   aw_query (int x_sector, int z_sector, int sequence[3][3]);
AWAPI int   aw_query_5x5 (int x_sector, int z_sector, int sequence[5][5]);
AWAPI int   aw_random (void);
AWAPI int   aw_world_attributes_change (void);
AWAPI int   aw_universe_attributes_change (void);
AWAPI int   aw_session (void);
AWAPI int   aw_world_eject (void);
AWAPI int   aw_sector_from_cell (int cell);
AWAPI int   aw_universe_ejection_add (void);
AWAPI int   aw_universe_ejection_delete (int address);
AWAPI int   aw_universe_ejection_lookup (void);
AWAPI int   aw_universe_ejection_next (void);
AWAPI int   aw_universe_ejection_previous (void);
AWAPI int   aw_object_click (void);
AWAPI int   aw_object_select (void);
AWAPI int   aw_avatar_click (int session_id);
AWAPI int   aw_address (int session_id);
AWAPI int   aw_url_send (int session_id, const char* url, const char* target);
AWAPI int   aw_url_click (const char* url);
AWAPI int   aw_teleport (int session_id);
AWAPI int   aw_world_ejection_add (void);
AWAPI int   aw_world_ejection_delete (void);
AWAPI int   aw_world_ejection_lookup (void);
AWAPI int   aw_world_ejection_next (void);
AWAPI int   aw_world_ejection_previous (void);
AWAPI int   aw_world_attribute_set (int attribute, char* value);
AWAPI int   aw_world_attribute_get (int attribute, int* read_only, char* value);
AWAPI int   aw_delete_all_objects (void);
AWAPI int   aw_cell_next (void);
AWAPI int   aw_world_reload_registry (void);
AWAPI int   aw_world_attributes_reset (void);
AWAPI int   aw_terrain_set (int x, int z, int count, int texture, short* heights);
AWAPI int   aw_terrain_query (int page_x, int page_z, unsigned long sequence);
AWAPI int   aw_terrain_next (void);
AWAPI int   aw_terrain_delete_all (void);
AWAPI int   aw_terrain_load_node (void);
AWAPI int   aw_console_message (int session_id);
AWAPI int   aw_user_data_set (void* data);
AWAPI void* aw_user_data (void);
AWAPI int   aw_avatar_set (int session_id);
AWAPI int   aw_botgram_send (void);
AWAPI int   aw_toolbar_click (void);
AWAPI int   aw_user_list (void);

/* world server admin methods below */

AWAPI int   aw_server_admin (const char* domain, int port, char* password,
              void** instance);
AWAPI int   aw_server_world_add (void);
AWAPI int   aw_server_world_delete (int id);
AWAPI int   aw_server_world_change (int id);
AWAPI int   aw_server_world_list (void);
AWAPI int   aw_server_world_start (int id);
AWAPI int   aw_server_world_stop (int id);
AWAPI int   aw_server_world_set (int id);

/* methods below are not currently available in the SDK */

AWAPI int   aw_contact_add (int citizen, unsigned short options);
AWAPI int   aw_contact_add_by_name (char* name, unsigned short options);
AWAPI int   aw_contact_change (int citizen, unsigned short options);
AWAPI int   aw_contact_delete (int citizen);
AWAPI int   aw_contact_list (int start);
AWAPI int   aw_afk_set (int flag);
AWAPI int   aw_telegram_send (char* to, char* msg);
AWAPI int   aw_join (int citizen);
AWAPI int   aw_join_reply (int citizen, int reply_rc);
AWAPI int   aw_password_send (void);
AWAPI int   aw_immigrate (void);
AWAPI int   aw_register (int renewal);
AWAPI int   aw_send_file (void);
AWAPI int   aw_send_file_reply (int reply_rc);
AWAPI void  aw_login_timeout_set (int timeout);
AWAPI int   aw_tunnel_set (const char* domain, unsigned short port);
AWAPI int   aw_tunnel_set_resolved (unsigned long address, unsigned short port);
AWAPI int   aw_proxy_set (const char* domain, unsigned short port);
AWAPI int   aw_proxy_set_resolved (unsigned long address, unsigned short port);
AWAPI int   aw_proxy_set_login (const char* name, const char* password);
AWAPI int   aw_connection (void);
AWAPI int   aw_connection_set (int type);
AWAPI int   aw_connection_state (void* instance);

#ifdef __cplusplus
}
#endif


